<template>
    <div class="">
            <page-header title="Flux des finances">

              <div slot="nav">
                <div class=" drowpdown mr-3">
                    <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-plus-circle mr-3"></i>Exporter vers
                    </button>
                    <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                          <a :href="excelUrl"  class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-excel t-plus-1 text-success fa-fw fa-lg "></i> EXCEL</a>
                    </div>
                    </div>
              </div>

            </page-header>
            <div class="col-md-12">
              <div :class="['card bg-transparent']" >
               <div :class="['card-header pl-0']">
                    <div class="card-title d-flex justify-content-start">

                        <div class="moisetannee">

                        </div>
                        <form method="POST" class="form-inline" @submit.prevent="mockSubmit">
                            <button v-show='false' type="button" class="btn btn-secondary mr-1 ml-1" @click=" showMonthYear=!showMonthYear"><i class="las la-exchange-alt"></i></button>
                            <vc-date-picker v-if="!showMonthYear" :columns="$screens({ default: 1, lg: 2 })"  @input="datepickerEvent" :masks="mask" mode="range" v-model="periode" class="ml-1"></vc-date-picker>
                            <select @change="moisEvent" class="form-control " v-if="showMonthYear" v-model="moreParams.mois">
                                <option value="tous">Tous</option>
                                <option :value="(key+1)" v-for="(month,key) in months" :key="key" v-text="month"></option>
                            </select>
                            <select @change="anneeEvent" class="form-control ml-1 " v-if="showMonthYear" v-model="moreParams.annee">
                                <option value="tous">Tous</option>
                                <option value="2020">2020</option>
                                <option value="2019">2019</option>
                                <option value="2018">2018</option>
                            </select>
                            <div class="input-group  mr-sm-2 ml-1">
                                <div class="input-group-prepend">
                                    <div class="input-group-text"><i class="las la-car"></i></div>
                                </div>
                                <select class="form-control" name="" id="" @change="filtreVehiculeEvent">
                                    <option value="all" >Tous</option>
                                    <option :value="v.id" v-for="(v,key) in options.vehicules" :key="key" >{{ v.libelle}}</option>
                                </select>
                            </div>
                        </form>
                    </div>
                    <div class="card-tools d-flex">
                          <select class="form-control mr-1" name="" id="" @change="filtreTypeEvent">
                                    <option value="all" >Tous les types de flux</option>
                                    <option value="App\Location" >Entrée</option>
                                    <option value="App\Depense" >Sortie</option>
                          </select>
                         <filter-bar ref="filterBar"></filter-bar>
                    </div>
              </div>
              <!-- /.card-header -->
              <div class="row">
                <div class="col">
                    <div class="info-box">
                        <span class="info-box-icon bg-success"><i class="las la-angle-double-up"></i></span>

                        <div class="info-box-content">
                            <span class="info-box-text">Entrées</span>
                            <span class="info-box-number">{{chiffre_affaire.incomings | monnaie}} F cfa</span>
                        </div>
                        <!-- /.info-box-content -->
                    </div>
                    <!-- /.info-box -->
                </div>
                <!-- /.col -->
                <div class="col">
                    <div class="info-box">
                        <span class="info-box-icon bg-danger"><i class="las la-angle-double-down"></i></span>

                        <div class="info-box-content">
                            <span class="info-box-text">Sorties</span>
                            <span class="info-box-number">{{chiffre_affaire.outgoings | monnaie}} F cfa</span>
                        </div>
                        <!-- /.info-box-content -->
                    </div>
                    <!-- /.info-box -->
                </div>
                <!-- /.col -->
                <!-- /.col -->
                <div class="col">
                    <div class="info-box">
                        <span  :class="['info-box-icon ',(chiffre_affaire.incomings-chiffre_affaire.outgoings)>0 ? ' bg-secondary' : 'bg-secondary']">
                          <i :class="['fi',(chiffre_affaire.incomings-chiffre_affaire.outgoings)>0 ? ' flaticon-046-graphics' : 'flaticon-048-graph-1']"></i>
                        </span>

                        <div class="info-box-content">
                            <span class="info-box-text">Résultat</span>
                            <span  :class="['info-box-number',(chiffre_affaire.incomings-chiffre_affaire.outgoings)>0 ? 'text-success' : (  (chiffre_affaire.incomings-chiffre_affaire.outgoings)==0  ? '' : 'text-danger' )]">{{chiffre_affaire.incomings-chiffre_affaire.outgoings | monnaie}} F cfa</span>
                        </div>
                        <!-- /.info-box-content -->
                    </div>
                    <!-- /.info-box -->
                </div>
                <!-- /.col -->
            </div>
              <div class="card-body table-responsive  p-0 position-relative " v-show="!NoDataForSearch && !NoDataAtAll" >
                    <vuetable :css="table" ref="vuetable" api-url="api/flux_finances" :fields="columns"
                           pagination-path=""
                           :per-page="15"
                           @vuetable:loading="onLoading"
                           @vuetable:loaded="onLoadingDone"
                           :append-params="moreParams"
                           :http-options="httpOptions"
                           detail-row-component="mdetail-row-depenses-for-mobile"
                           @vuetable:pagination-data="onPaginationData">

                            <template slot="type" slot-scope="props">
                                 <span  v-if="props.rowData.type=='Sortie'"  class="btn btn-label-danger btn-sm btn-bold btn-upper d-inline-block w-100 "> <i class="fa fa-arrow-down d-inline mr-1"></i>
                                 <span class="hidden-xs">{{ props.rowData.type }} </span></span>
                                 <span v-else   class="btn btn-label-success btn-sm btn-bold btn-upper d-inline-block w-100"> <i class="fa fa-arrow-up d-inline mr-1"></i><span class="hidden-xs">{{ props.rowData.type }}</span> </span>

                            </template>
                            <template slot="vehicule" slot-scope="props">
                                    {{ props.rowData.vehicule !=null  ? props.rowData.vehicule.libelle : 'Inconnue'}}
                            </template>
                            <template slot="flux" slot-scope="props">
                              {{ props.rowData.flux}}
                            </template>
                          <template slot="montant" slot-scope="props">
                                 {{ monnaie(props.rowData.montant) }} <span>F cfa</span>
                          </template>
                          <template slot="date_created" slot-scope="props">
                                {{ props.rowData.date_transaction | toDate }}

                          </template>
                    </vuetable>
              </div>
              <pa ref="pagination" :is-loading="isLoading"  :pager="[15,25,50,100]" @vuetable-pagination:change-page="onChangePage" v-show="!NoDataForSearch && !NoDataAtAll"   ></pa>
              <!-- /.card-body -->
               </div>
               <no-data-in-search v-show="pageInit && !isLoading" :search="searchTxt" :message-for-searching="searchTxt" :show="NoDataForSearch" :data-empty="NoDataAtAll"></no-data-in-search>
</div>
    </div>
</template>

<script>

   import  Vuetable from "vuetable-2/src/components/Vuetable";
   import pa from './../../components/pagination/Pagination'
    import CrudDepense from './../../components/depenses/CrudDepense'
   import Form from "./../../classes/Form"
   import Master from "./../Master.vue";


    export default {
        mixins: [Master],
        data(){
            return{

                //Liste des voitures
                options : { vehicules :[]},
                vehicule:'',

                modeEdit:false,
                months:moment.monthsShort(),
                showMonthYear:true,
                ftime:true,
                hasData:false,
                vehicule :"",
                tdepense :"",
                mask:{

                    input: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                    data: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                  },
                periode:"",
                chiffre_affaire : {
                  incomings: 0,
                  outgoings:0,
                },
                moreParams:{
                  filter:"",
                  filter_date_fin_prev:"",
                  filter_date_dbt:"",
                  type:'',
                  vehicule_id:"",
                  annee:moment().year(),
                  mois:moment().month()+1,
                },
                isLoading:false,
                columns : [
                 {
                name: '__slot:type',   // <----
                title: "Type",
                width:"50px"
                },
                {
                name: '__slot:vehicule',   // <----
                title: "Voiture",

                },

                {
                name: '__slot:flux',   // <----
                title: "Description",

                },
                {
                name: '__slot:montant',   // <----
                title: "Montant",
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                },

                {
                name: '__slot:date_created',   // <----
                title: "D. de transaction",
                titleClass: 'center aligned hidden-xs',
                dataClass: 'center aligned hidden-xs'
                }
                ],
                  table: {
                    tableWrapper: '',
                    tableHeaderClass: 'mb-0',
                    tableBodyClass: 'mb-0',
                    tableClass: 'table table-striped table-hover',
                    ascendingIcon: 'fa fa-chevron-up',
                    descendingIcon: 'fa fa-chevron-down',
                    ascendingClass: 'sorted-asc',
                    descendingClass: 'sorted-desc',
                    sortableIcon: 'fa fa-sort',
                    detailRowClass: 'vuetable-detail-row',
                    handleIcon: 'fa fa-bars text-secondary',
                    renderIcon(classes, options) {
                      return `<i class="${classes.join(' ')}"></span>`
                    }
                  }
            }
        },
        created()
        {
            this.modeEdit = false
            var now  = moment();
            var end = moment().subtract(3,'months')

            this.fetchOptions()
            this.periode =
            {
              start:end.toDate(),
              end:now.toDate()
            }

        },
        mounted()
        {
                this.$events.$on('filter-set', eventData => this.onFilterSet(eventData))
                this.$events.$on('filter-reset', e => this.onFilterReset())
        },
        computed:
        {
           excelUrl()
           {
             return '/flux-finances/export?format=excel&filter='+this.moreParams.filter+'&filter_date_fin_prev='+this.moreParams.filter_date_dbt+'&filter_date_dbt='+this.moreParams.filter_date_dbt+'&vehicule_id='+this.moreParams.vehicule_id+'&annee='+this.moreParams.annee+'&mois='+this.moreParams.mois+'&type='+this.moreParams.type
           },
           pdfUrl()
           {
             return '/flux-finances/export?format=pdf&q='+this.searchTxt
           },
            ModalTitle ()
            {
              return  this.modeEdit ? " Modification d'une dépense"  : " Ajout d'une dépense"
            },
            ModalAction ()
            {
              return  this.modeEdit ? " Modifier"  : " Ajouter"
            },
            shouldGoToFirstPage()
            {
              if(this.$refs.vuetable)
              {
                return (this.$refs.vuetable.tableData.length) - 1 == 0
              }
              else
              {
                return false
              }
            },
            filterBarIsFilled()
            {
                if(this.moreParams.hasOwnProperty('filter') || isDefined(this.dataForSearched))
                  return (this.moreParams.filter != "" || isDefined(this.dataForSearched)) ? true : false
                else
                 return false
            },
            searchTxt()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  if(isDefined(this.dataForSearched) && this.moreParams.filter!="")
                   {
                     return "Aucune donnée trouvée pour la recherche <b>"+this.moreParams.filter+" </b> pour : "+this.dataForSearched
                   }
                   else if(!isDefined(this.dataForSearched) && this.moreParams.filter!="")
                   {
                     return "Aucune donnée trouvée pour la recherche <b>"+this.moreParams.filter+" </b>"
                   }
                   else if(isDefined(this.dataForSearched) && this.moreParams.filter=="")
                   {
                     return "Aucune donnée trouvée  pour : <b>"+this.dataForSearched+"</b>"
                   }
                   else
                   {
                     return this.moreParams.filter
                   }
                else
                 {
                   if(isDefined(this.dataForSearched))
                       return "Aucune donnée trouvée  pour : "+this.dataForSearched
                    else
                       return ""
                 }
            },
            dataForSearched()
            {
                var m = !isDefined(this.moreParams.mois)  ?  ""  : ((!isNaN(this.moreParams.mois)) ? moment().month(parseInt(this.moreParams.mois)-1).format('MMMM') : this.moreParams.mois)
                var y = isDefined(this.moreParams.annee) ? this.moreParams.annee  : "" 

                if(m=="" || y=="")
                return ""
                else
                return m+" "+y
            },
            NoDataForSearch()
            {

              return (this.hasData == false && this.filterBarIsFilled == true ) ? true : false

            },

            NoDataAtAll()
            {

              return (this.hasData == false && this.filterBarIsFilled == false ) ? true : false

            },
            datepicker()
            {
              if(this.$refs.filterdate.inputValue!=""  &&  this.$refs.filterdate.inputValue!=null && this.$refs.filterdate.inputValue!=undefined )
               {
                     return moment(this.periode.start).format('YYYY-MM-DD')
               }
               else
               {
                 return ""
               }

            }
        },
        methods:
        {
            fetchOptions()
            {
                axios.get("/api/dispatcher/options/flux-finances").then((response) =>
                    {
                        this.options.vehicules = response.data.vehicules;

                    },
                    (error) =>
                    {
                        this.isLoading = false
                    });
            },

            datepickerEvent(periode)
            {
                 this.moreParams.filter_date_dbt = moment(periode.start).format('YYYY-MM-DD')
                 this.moreParams.filter_date_fin_prev = moment(periode.end).format('YYYY-MM-DD')
                 Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            anneeEvent(e)
            {
                 this.moreParams.annee = e.target.value
                 Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            moisEvent(e)
            {
                 this.moreParams.mois = e.target.value
                 Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            filtreVehiculeEvent(e)
            {
                 this.moreParams.vehicule_id = e.target.value
                 Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
              filtreTypeEvent(e)
            {
                 this.moreParams.type = e.target.value
                 Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            mockSubmit()
            {

            },
            formatDate: function(value, fmt)
            {
               return  toDateFormat(value, fmt)
            },
            onPaginationData (paginationData)
            {
              if(this.pageInit==false)
                 this.pageInit =true
              else
              {

              }
              
              this.hasData = paginationData.flux.data.length > 0
              this.chiffre_affaire.incomings = paginationData.incomings
              this.chiffre_affaire.outgoings = paginationData.outgoings
              this.$refs.vuetable.tablePagination =paginationData.flux
              this.$refs.vuetable.tableData = paginationData.flux.data
              this.$refs.pagination.setPaginationData(paginationData.flux)
            },
            onChangePage (page)
            {

               this.$refs.vuetable.changePage(page)
            },
            onLoading()
            {

               this.isLoading = true
                if(this.ftime==false)
                {
                    $('.content-wrapper').block({
                        message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>',
                        css: { border: 'none' },

                            // styles for the overlay
                            overlayCSS:  {
                                backgroundColor: '#000',
                                opacity:         0.02,
                                cursor:          'wait'
                            },
                    });

                }
                this.ftime = false
            },
            onLoadingDone()
            {
               this.isLoading = false
                if(this.ftime==false)
                {
                    $('.content-wrapper').unblock()
                }
            },

            onFilterSet (filterText)
            {
                this.moreParams.filter = filterText
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            onFilterReset () {
                this.moreParams.filter = ""
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            //Retire un role de la BDD
             remove(e)
             {


                  //On demande la confirmation de la suppression
                    alertConfirm("Voulez-vous supprimer cette dépense ?","Suppréssion d'une dépense")
                    .then(result => {
                        //On réinitialise le chargement
                        this.isLoading = true
                        if(result)
                        {
                           axios.delete("api/depenses/"+e).then((response) =>
                            {

                                  // on rafraichit la page de donnée actuelle
                                  !this.shouldGoToFirstPage ? this.$refs.vuetable.reload() : this.$refs.vuetable.refresh()
                                  //on notifie l'effectivité de la suppréssion
                                  flash("<span>Supprimé <strong>avec succès</strong></span>")
                                  //On réinitialise le chargement
                                  this.isLoading = false
                            },
                            (error) =>
                            {
                              this.isLoading = false
                            });
                        }
                    })
                    .catch(error => {
                        reject(error);
                    });
             },
            //Ajoute un role dans la BDD
            apresAjoutDepense()
            {
                  this.$refs.vuetable.refresh()
            },
            //Actualise  un role dans la BDD
            apresModificationDepense()
            {

              this.$refs.vuetable.reload()

            },
            //On affiche le modal pour la création
            showModalOnCreate()
            {

                window.event.$emit('show-modal-for-adding-depense')

            },
            //On affiche le modal pour l'édition
            showModalOnEdit(entity)
            {

                  window.event.$emit('show-modal-for-updating-depense')
             },
              //Initialisation du formulaire
              reset()
             {
                  this.form.reset();
                  this.$refs['inputModal'].hide()
                  this.modeEdit = false
                  this.isLoading = false
                  if(this.moreParams.hasOwnProperty('filter'))
                  this.moreParams.filter=""
             },
             

             download()
             {
               var vm = this
                axios.get("/api/flux_finances/export",{params:this.moreParams}).then((response) => 
                { 
                    
                    const url = window.URL.createObjectURL(new Blob([response.data]));
                    const link = document.createElement('a');
                    link.href = url;
                    link.setAttribute('download','users.xlsx');
                    document.body.appendChild(link);
                    link.click();
                      
                },
                (error) =>
                {
                  this.isLoading = false
                });
             }

        },
        components:
        {

            Vuetable,CrudDepense,
            pa
        }
    }
</script>
<style scoped>
.info-box {
    min-height: 40px;
}
  .info-box .info-box-icon
  {
    border-radius: 100%;
    -webkit-box-align: center;
    align-items: center;
    display: -webkit-box;
    display: flex;
    font-size: 1.875rem;
    -webkit-box-pack: center;
    justify-content: center;
    text-align: center;
    width: 40px;
    height: 40px;
  }
.info-box .info-box-number {
    display: block;
    font-weight: 700;
    font-size: 20.5px;
}
</style>
